package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.common.module.entity.CtopOauthToken;
import cn.com.ctop.common.module.service.ICtopOauthTokenService;
import cn.com.ctop.kuaishou.modules.report.service.IKuaishouAudienceReportDailyService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.jeecg.common.util.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 * 快手广告主分天数据
 *
 * @author syh
 */
@Component
public class KuaishouDailyAudienceReportJob {
    @Autowired
    private ICtopOauthTokenService tokenService;
    @Autowired
    private IKuaishouAudienceReportDailyService kuaishouAudienceReportDailyService;
    static ExecutorService executorService = Executors.newFixedThreadPool(6);

    @XxlJob("kuaishouDailyAudienceReportJob")
    public void execute() throws Exception {
        //查询两天前数据
        String date = DateUtils.getLastDay(DateUtils.date2Str(), 2);
        List<CtopOauthToken> tokens = tokenService.selectKuaiShouToken();
        if (null == tokens || tokens.isEmpty()) {
            XxlJobHelper.log("定时获取人群分析报表数据异常：未获取到可用的token");
            XxlJobHelper.handleFail();
            return;
        }
        tokens.forEach(token -> executorService.submit(() -> {
            kuaishouAudienceReportDailyService.crowdAnalysisReport(token, date, "province", 1, 2000);
            kuaishouAudienceReportDailyService.crowdAnalysisReport(token, date, "city", 1, 2000);
            kuaishouAudienceReportDailyService.crowdAnalysisReport(token, date, "gender", 1, 2000);
            kuaishouAudienceReportDailyService.crowdAnalysisReport(token, date, "ageSegment", 1, 2000);
            kuaishouAudienceReportDailyService.crowdAnalysisReport(token, date, "clientId", 1, 2000);
            kuaishouAudienceReportDailyService.crowdAnalysisReport(token, date, "businessInterestTags", 1, 2000);
        }));
    }
}
